<template>
  <div>
    <mt-page-title>
      <h1 class="has-text-weight-bold is-size-3">Liste des activités</h1>
    </mt-page-title>
    <div>
      <div class="columns is-vcentered mt-marginless-bottom">
        <h3 class="has-text-weight-bold has-text-grey is-size-5 column">Nombre total d'activités : {{ total }}</h3>
        <div class="column is-narrow">
          <nuxt-link :to="{ name: 'profil-dashboard-activites-creer' }" tag="button" class="is-primary button"
            ><b-icon icon="plus" />&nbsp;&nbsp;Créer une activité</nuxt-link
          >
        </div>
      </div>
      <mt-list v-slot="{ item: activite }" :list="activites">
        <mt-list-item>
          <div class="columns is-vcentered">
            <nuxt-link
              :to="{ name: 'profil-dashboard-activites-id-editer', params: { id: activite.id } }"
              class="columns column mt-marginless-bottom"
            >
              <div class="column">{{ dateFormat(activite.dateDebut) }} - {{ dateFormat(activite.dateFin) }}</div>
              <div class="column">
                <b-tag :class="resolveTypeActivite(activite, 'mt-background-type-').class">
                  {{ activite.typeActivite.libelle }}
                </b-tag>
                <span>&nbsp;{{ activite.nom }}</span>
              </div>
              <div class="column">
                {{ activite.organisme.libelle }}
              </div>
            </nuxt-link>
            <div class="column is-narrow">
              <b-button type="is-danger" icon-left="delete" @click="confirmeSupprimer(activite)">Supprimer</b-button>
            </div>
          </div>
        </mt-list-item>
      </mt-list>
      <mt-modal-action type-delete :ouvert.sync="ouvertDelete" @action="supprimerActivite(monActivite)">
        Êtes-vous certain(e) de vouloir supprimer l'activité' ?
      </mt-modal-action>
      <b-pagination
        :total="total"
        :current="pageCourante"
        :per-page="parPage"
        order="is-centered"
        aria-next-label="Activités suivante"
        aria-previous-label="Activités précedente"
        aria-page-label="Activités"
        aria-current-label="Page courante"
        @change="getActivites"
      />
    </div>
  </div>
</template>

<script>
import { DateTime } from 'luxon';
import MtPageTitle from '~/components/base/page-title/index';
import MtList from '~/components/base/list/index';
import MtListItem from '~/components/base/list/list-item';
import { classResolver } from '~/components/mixins/activityMixin';
import MtModalAction from '~/components/modal/mt-modal-action';
import userMixin from '~/components/mixins/userMixin';

export default {
  layout: 'dashboard',
  components: {
    MtPageTitle,
    MtList,
    MtListItem,
    MtModalAction,
  },
  mixins: [classResolver, userMixin],
  watch: {
    organisme: {
      handler() {
        this.getActivites(1);
      },
    },
  },
  async asyncData({ $api }) {
    const pageCourante = 1;
    const parPage = 30;
    const {
      content: activites,
      totalElements: total,
      numberOfElements: nombrePageCourante,
    } = await $api.organisme().activites(pageCourante - 1, parPage);
    return {
      activites,
      pageCourante,
      parPage,
      total,
      nombrePageCourante,
      ouvertDelete: false,
      monActivite: null,
    };
  },
  methods: {
    dateFormat(date) {
      return DateTime.fromJSDate(date)
        .setLocale('fr')
        .toLocaleString();
    },
    async getActivites(page) {
      this.pageCourante = page;
      ({
        content: this.activites,
        totalElements: this.total,
        numberOfElements: this.nombrePageCourante,
      } = await this.$api.organisme().activites(this.pageCourante - 1, this.parPage));
    },
    confirmeSupprimer(activite) {
      this.ouvertDelete = true;
      this.monActivite = activite;
    },
    async supprimerActivite(activite) {
      try {
        await this.$api.activites.delete(activite.id);
        let page = this.pageCourante;
        if (this.nombrePageCourante === 1 && this.pageCourante > 1) {
          page = this.pageCourante - 1;
        }
        this.getActivites(page);
      } catch ({
        response: {
          status,
          data: { message },
        },
      }) {
        this.$buefy.notification.open({
          message,
          type: 'is-danger',
          duration: 5000,
        });
      }
    },
  },
};
</script>

<style scoped lang="scss">
/deep/ {
  .mt-list {
    margin-top: 0.5rem;
  }
}
</style>
